#! /bin/sh
# Generated automatically from ml.in by configure.
#---------------------------------------------------------------------------#
# Copyright (C) 1995-1997 The University of Melbourne.
# This file may only be copied under the terms of the GNU General
# Public License - see the file COPYING in the Mercury distribution.
#---------------------------------------------------------------------------#
#
# ML - Mercury Linker.
#
# Invokes GCC with the appropriate options to link in the Mercury library.
#
# Usage: see below.
#
# Environment variables: MERCURY_C_LIB_DIR, MERCURY_DEFAULT_GRADE, ...

Help="\
Name: ml - Mercury Linker
Usage: ml [<ml options>] [-- <gcc options>] files...
Options:
	-h, --help
		Print this help message.
	-v, --verbose
		Echo the gcc command line before executing it.
	--mercury-libs {shared, static, none}
		Specify which version of the standard Mercury libraries to
		link with:
			--mercury-libs shared
				Link with the shared libraries (*.so),
				if possible, otherwise with the static ones.
			--mercury-libs static
				Link with the static libraries (*.a).
			--mercury-libs none
				Don't link in the Mercury standard libraries.
	-shared, --shared
		Similar to \`--mercury-libs shared', but applies to all
		libraries, not just the standard Mercury libraries.
	-static, --static
		Similar to \`--mercury-libs static', but applies to all
		libraries, not just the standard Mercury libraries.
	--make-shared-lib
		Produce a shared library, rather than an executable.
	-R <directory>, --shared-lib-dir <directory>
		Include <directory> in the list of directories that the
		dynamic linker will use to search for shared libraries.
	--no-demangle
		Don't pipe the output of the linker through the Mercury
		demangler.
	-g, --no-strip
		Do not strip debugging information.
	-s <grade>, --grade <grade>
	--asm-labels
	--gcc-non-local-gotos
	--gcc-global-registers
	-p, --profiling
	--profile-calls
	--profile-time
	--debug
	--use-trail
	--args {simple, compact}
	--pic-reg
		See the documentation in the \"Invocation\" section
		of the Mercury User's Guide."

FULLARCH=m68k-unknown-linux-gnu
NONSHARED_LIB_DIR=${MERCURY_NONSHARED_LIB_DIR=/usr/lib/nonshared}
DEFAULT_LIBDIR=/usr/lib/mercury/lib
LIBDIR=${MERCURY_C_LIB_DIR=$DEFAULT_LIBDIR}
DEFAULT_GRADE=${MERCURY_DEFAULT_GRADE=asm_jump.gc}
# DEMANGLER=${MERCURY_DEMANGLER=/usr/lib/mercury/bin/m68k-unknown-linux-gnu/mdemangle}
DEMANGLER=${MERCURY_DEMANGLER=mdemangle}
CC=${MERCURY_C_COMPILER="gcc"}
MKFIFO=${MERCURY_MKFIFO="/usr/bin/mkfifo"}
EXE_RPATH_OPT=${MERCURY_EXE_RPATH_OPT="-Wl,-rpath,"}
EXE_RPATH_SEP=${MERCURY_EXE_RPATH_SEP=" -Wl,-rpath,"}
EXT_FOR_SHARED_LIB=${MERCURY_EXT_FOR_SHARED_LIB="a"}
LINK_SHARED_OBJ=${MERCURY_LINK_SHARED_OBJ="gcc -shared"}
SHLIB_RPATH_OPT=${MERCURY_SHLIB_RPATH_OPT="-Wl,-rpath,"}
SHLIB_RPATH_SEP=${MERCURY_SHLIB_RPATH_SEP=" -Wl,-rpath,"}
SHARED_LIBS=${MERCURY_SHARED_LIBS="`gcc -print-libgcc-file-name` -lm -lc"}

verbose=false
case $FULLARCH in
	*-win95|*-winnt|*-win32|*-cygwin32)
		# `gcc -s' is broken in gnu-win32
		strip=false
		;;
	*)
		strip=true
		;;
esac
mercury_libs=default
demangle=true
MAYBE_STATIC_OPT=""
make_shared_lib=false
user_shlib_dirs=""

# include the file `init_grade_options.sh-subr'

#---------------------------------------------------------------------------#
# Copyright (C) 1997 The University of Melbourne.
# This file may only be copied under the terms of the GNU General
# Public License - see the file COPYING in the Mercury distribution.
#---------------------------------------------------------------------------#
#
# parse_grade_options.sh-subr:
#	An `sh' subroutine for initializing grade-related options.
#	Used by the `ml' and `mgnuc' scripts.
#
#	The code here should be inserted before a script's option-parsing
#	loop.  The invoking script must define a DEFAULT_GRADE option.
#
#---------------------------------------------------------------------------#

asm_labels=true
non_local_gotos=true
global_regs=true
gc_method=conservative
profile_time=false
profile_calls=false
use_trail=false
args_method=compact
debug=false

case $# in
	0) set - "--grade $DEFAULT_GRADE" ;;
	0) set - "--grade $DEFAULT_GRADE" "$@" ;;
esac

#---------------------------------------------------------------------------#

while : ; do
    case "$1" in
	-h|--help|"-?")
		echo "$Help"
		exit 0
		;;
	-v|--verbose)
		verbose=true
		;;
	--demangle)
		demangle=true
		;;
	--no-demangle)
		demangle=false
		;;
	--strip)
		strip=true
		;;
	-g|--no-strip)
		strip=false
		;;
	--make-shared-lib)
		make_shared_lib=true
		# on some targets, stripping shared libraries will
		# make them unusable, I think, so don't strip
		strip=false
		;;
	--no-libs)
		progname=`basename $0`
		cat 1>&2 << EOF
$progname: Warning: option \`--no-libs' is deprecated --
$progname:   please use the new option \`--mercury-libs none' instead.
$progname:   Support for \`--no-libs' may be removed in a future release.
EOF
		mercury_libs=none
		;;
	--mercury-libs)
		case "$2" in
			shared|static|none|default)
				mercury_libs="$2"
				shift ;;
			*)
				progname=`basename $0`
				cat 1>&2 << EOF
$progname: Error: parameter to \`--mercury-libs' option should be either
$progname:   \`shared', \`static', \`none', or \`default', not \`$2'.
$progname: Try `$0 --help' for help.
EOF
				exit 1
				;;
		esac
		;;
	-shared|--shared)
		MAYBE_STATIC_OPT=""
		case $mercury_libs in static|default)
			mercury_libs=shared ;;
		esac
		;;
	-static|--static)
		case $FULLARCH in
		    *-linux*)
		    	# On Linux, if we're linking statically, we need to
		    	# pass `-defsym _DYNAMIC=0' to the linker, to avoid
		    	# undefined references to _DYNAMIC in
		    	# boehm_gc/dyn_load.c.
		    	# (We might eventually need similar treatment
		    	# for other OSs too)
			MAYBE_STATIC_OPT="-static -Wl,-defsym,_DYNAMIC=0"
			;;
		    *)
			MAYBE_STATIC_OPT=-static
			;;
		esac
		case $mercury_libs in shared|default)
			mercury_libs=static ;;
		esac
		;;
	-R|--shared-lib-dir)
		dir="$2"
		user_shlib_dirs="$user_shlib_dirs $dir"
		shift
		;;
	-R*)
		dir="` expr $1 : '-R\(.*\)' `"
		user_shlib_dirs="$user_shlib_dirs $dir"
		;;

	# include the file `parse_grade_options.sh-subr'
	
#---------------------------------------------------------------------------#
# Copyright (C) 1997 The University of Melbourne.
# This file may only be copied under the terms of the GNU General
# Public License - see the file COPYING in the Mercury distribution.
#---------------------------------------------------------------------------#
#
# parse_grade_options.sh-subr:
#	An `sh' subroutine for parsing grade-related options.
#	Used by the `ml' and `mgnuc' scripts.
#
#	The code here should be inserted in the case statement in a scripts
#	option-parsing loop.
#
#---------------------------------------------------------------------------#

	--asm-labels)
		asm_labels=true ;;
	--no-asm-labels)
		asm_labels=false ;;

	--gcc-non-local-gotos)
		non_local_gotos=true ;;
	--no-gcc-non-local-gotos)
		non_local_gotos=false ;;

	--gcc-global-registers)
		global_regs=true ;;
	--no-gcc-global-registers)
		global_regs=false ;;

	--debug)
		debug=true ;;
	--no-debug)
		debug=false ;;

	--gc)
		shift
		case "$1" in
			accurate|conservative|none)
				gc_method=$1 ;;
			*)
				echo "$0: invalid gc method \`$1'" 1>&2
				exit 1
				;;
		esac
		;;

	-p|--profiling)
		profile_time=true
		profile_calls=true
		;;
	-p-|--no-profiling)
		profile_time=false
		profile_calls=false
		;;
	--profile-time)
		profile_time=true ;;
	--no-profile-time)
		profile_time=false ;;
	--profile-calls)
		profile_calls=true ;;
	--no-profile-calls)
		profile_calls=false ;;

	--use-trail)
		use_trail=true ;;
	--no-use-trail)
		use_trail=false ;;

	--args)
		shift
		case "$1" in
			simple|compact)
				args_method=$1;;
			*)
				echo "$0: invalid arg method \`$1'" 1>&2
				exit 1
				;;
		esac
		;;

	--pic-reg)
		pic_reg=true ;;
	--no-pic-reg)
		pic_reg=false ;;

	-s|--grade)
		shift
		grade="$1";

		# Convert a grade to a set of options.
		#
		# IMPORTANT: any changes to the handling of grades here
		# may also require changes to
		#	runtime/mercury_grade.h
		#	compiler/handle_options.m
		#	scripts/ml.in

		case "$grade" in
			*.debug)
				debug=true
				grade="` expr $grade : '\(.*\).debug' `"
				;;
			*)	debug=false
				;;
		esac

		case "$grade" in
			*.sa)
				args_method=simple
				grade="` expr $grade : '\(.*\).sa' `"
				;;
			*)	args_method=compact
				;;
		esac

		case "$grade" in
			*.tr)	use_trail=true
				grade="` expr $grade : '\(.*\).tr' `"
				;;
			*)	use_trail=false
				;;
		esac

		case "$grade" in
			*.prof)
				profile_time=true
				profile_calls=true
				grade="` expr $grade : '\(.*\).prof' `"
				;;
			*.proftime)	
				profile_time=true
				profile_calls=false
				grade="` expr $grade : '\(.*\).proftime' `"
				;;
			*.profcalls)	
				profile_time=false
				profile_calls=true
				grade="` expr $grade : '\(.*\).profcalls' `"
				;;
			*)
				profile_time=false
				profile_calls=false
				;;
		esac

		case "$grade" in
			*.agc)	gc_method=accurate
				grade="` expr $grade : '\(.*\).agc' `"
				;;
			*.gc)	gc_method=conservative
				grade="` expr $grade : '\(.*\).gc' `"
				;;
			*)	gc_method=none
				;;
		esac

		case "$grade" in
			asm_fast)
				global_regs=true
				non_local_gotos=true
				asm_labels=true
				;;
			fast)
				global_regs=true
				non_local_gotos=true
				asm_labels=false
				;;
			reg)
				global_regs=true
				non_local_gotos=false
				asm_labels=false
				;;
			asm_jump)
				global_regs=false
				non_local_gotos=true
				asm_labels=true
				;;
			jump)
				global_regs=false
				asm_labels=false
				non_local_gotos=true
				;;
			none)
				global_regs=false
				asm_labels=false
				non_local_gotos=false
				;;
			debug)
				debug=true
				global_regs=false
				asm_labels=false
				non_local_gotos=false
				;;
			*)
				echo "$0: invalid grade \`$grade'" 1>&2;
				exit 1
				;;
		esac
		;;
	-s*)
		grade="` expr $1 : '-s\(.*\)' `"
		# just insert it as `--grade $grade' and then reparse it
		case $# in
			0) set - "x --grade $grade" ;;
			0) set - "x --grade $grade" "$@" ;;
		esac
		;;

	--)
		shift
		break ;;
	*)
		break ;;
    esac
    shift
done

case $mercury_libs in default)
	mercury_libs=shared
	case $FULLARCH in i?86-*-linux*)
		# shared libraries are not the default on Linux
		# -- see README.Linux
		case $make_shared_lib in false)
			mercury_libs=static
			;;
		esac
		;;
	esac
	;;
esac

#
# compute the grade from the options settings
#

case $non_local_gotos,$global_regs in
	true,true) 	GRADE="fast" ;;
	true,false)  	GRADE="jump" ;;
	false,true)  	GRADE="reg" ;;
	false,false)   	GRADE="none" ;;
esac
case $asm_labels in
	true)		GRADE="asm_$GRADE" ;;
	false)		;;
esac
case $gc_method in
	conservative)	GRADE="$GRADE.gc" ;;
	accurate)	GRADE="$GRADE.agc" ;;
esac
case $profile_time,$profile_calls in
	true,true)	GRADE="$GRADE.prof" ;;
	true,false)	GRADE="$GRADE.proftime" ;;
	false,true)	GRADE="$GRADE.profcalls" ;;
	false,false)	;;
esac
case $use_trail in
	true)		GRADE="$GRADE.tr" ;;
	false)		;;
esac
case $args_method in
	simple)		GRADE="$GRADE.sa" ;;
	compact)	;;
esac
case $debug in
	true)		GRADE="$GRADE.debug" ;;
	false)		;;
esac

case "$GRADE" in
	*.gc.prof*)
		LIBGC="-lgc_prof"
		LIBGC_STATIC="$LIBDIR/$FULLARCH/libgc_prof.a"
		;;
	*.gc*)
		LIBGC="-lgc"
		LIBGC_STATIC="$LIBDIR/$FULLARCH/libgc.a"
		;;
	*)
		LIBGC=
		LIBGC_STATIC=
		;;
esac

case $strip in
	true)	STRIP_OPTS="-s" ;;
	false)  STRIP_OPTS="" ;;
esac

case $make_shared_lib in
    true)
	LINKER="$LINK_SHARED_OBJ"
	RPATH_OPT="$SHLIB_RPATH_OPT"
	RPATH_SEP="$SHLIB_RPATH_SEP"
	STDLIBS="$SHARED_LIBS"
	;;
    false)
	LINKER="$CC"
	RPATH_OPT="$EXE_RPATH_OPT"
	RPATH_SEP="$EXE_RPATH_SEP"
	STDLIBS="-lm"
	;;
esac

LIBDIR_OPTS="
	-L$LIBDIR/$GRADE/$FULLARCH
	-L$LIBDIR/$FULLARCH
"
case $mercury_libs in
	shared)
		LIBS=${MERCURY_LIBS="-lmercury -lmer $LIBGC $STDLIBS"}
		merc_shlib_dirs="$merc_shlib_dirs $LIBDIR/$GRADE/$FULLARCH"
		merc_shlib_dirs="$merc_shlib_dirs $LIBDIR/$FULLARCH"
		;;
	static) LIBS=${MERCURY_LIBS="\
			$LIBDIR/$GRADE/$FULLARCH/libmercury.a \
			$LIBDIR/$GRADE/$FULLARCH/libmer.a \
			$LIBGC_STATIC \
			$STDLIBS"}
		merc_shlib_dirs=""
		;;
	none)	LIBS="$STDLIBS"
		LIBDIR_OPTS=""
		merc_shlib_dirs=""
		;;
esac

RPATH_OPT_LIST=
# only set RPATH_OPT_LIST if the system supports shared libraries
case $EXT_FOR_SHARED_LIB in so)
	prev=""
	for dir in $user_shlib_dirs $merc_shlib_dirs 'kludge for broken shells'
	do
	    case "$dir" in
		'kludge for broken shells')
		    ;;
		*)
		    case "$prev" in
			"") RPATH_OPT_LIST="$RPATH_OPT$dir" ;;
			*)  RPATH_OPT_LIST="$RPATH_OPT_LIST$RPATH_SEP$dir" ;;
		    esac
		    ;;
	    esac
	    prev=$dir
	done
	;;
esac

# On Irix 5, grades `fast' and `jump' only work in non_shared mode.
case $FULLARCH in
    *-sgi-irix5*)
	case $non_local_gotos in
	    true)
		ARCH_OPTS=-non_shared
		NONSHARED_PATH="$NONSHARED_LIB_DIR:/usr/lib/nonshared"
		LIBRARY_PATH="$NONSHARED_PATH:$LIBRARY_PATH"
		export LIBRARY_PATH
		;;
	esac
	;;
esac

case "$MKFIFO" in
    none) demangle=false ;;
esac

case $verbose in
    true)
	echo "ml: using grade \`$GRADE'"
	case $demangle in
	    false)
		echo $LINKER $STRIP_OPTS $MAYBE_STATIC_OPT $ARCH_OPTS \
			"$@" $LIBDIR_OPTS $RPATH_OPT_LIST $LIBS
		;;
	    true)
		echo $LINKER $STRIP_OPTS $MAYBE_STATIC_OPT $ARCH_OPTS \
			"$@" $LIBDIR_OPTS $RPATH_OPT_LIST $LIBS "|"
		echo "$DEMANGLER"
		;;
	esac
	;;
esac

case $demangle in
    true)
	# we would like to just run $CC and pipe the result into $DEMANGLER,
	# but `$CC | $DEMANGLER' would return the wrong exit status, so
	# we need to use a named pipe; if the system doesn't have named
	# pipes, then we don't use the demangler

		# create the pipe, making sure we remove it if interrupted
	old_umask=`umask`
	umask 022
	ML_TMPDIR=/tmp/ml$$
	PIPE=$ML_TMPDIR/pipe
	mkdir $ML_TMPDIR
	case $? in 
		0) ;;
		*) echo "Unable to create temporary pipe" 1>&2
		   exit 1 ;;
	esac
	trap 'rm -rf $ML_TMPDIR; exit 1' 1 2 3 13 15 
	umask $old_umask
	$MKFIFO $PIPE
		# execute the demangler in the background, with stdin 
		# coming from the pipe and with stdout redirected to stderr
	exec $DEMANGLER 1>&2 < $PIPE &
		# redirect our stdout and stderr into the pipe
	exec >$PIPE 2>&1
		# now we can remove the pipe; since is an open file, it will
		# stay around until $CC and $DEMANGLER exit
	rm -rf $ML_TMPDIR
		# finally execute $CC; stdout & stderr will
		# go via the pipe to $DEMANGLER and then to stderr
	;;
esac
case $# in
	0) exec $LINKER $STRIP_OPTS $MAYBE_STATIC_OPT $ARCH_OPTS \
		$LIBDIR_OPTS $RPATH_OPT_LIST $LIBS ;;
	*) exec $LINKER $STRIP_OPTS $MAYBE_STATIC_OPT $ARCH_OPTS "$@" \
		$LIBDIR_OPTS $RPATH_OPT_LIST $LIBS ;;
esac
